<?php
/*********************************************************************************
 * The contents of this file are subject to the TimeTrex Public License Version
 * 1.1.0 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.TimeTrex.com/TPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by TimeTrex" logo and
 *    (ii) the TimeTrex copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: TimeTrex Open Source
 * The Initial Developer of the Original Code is TimeTrex Payroll Services
 * Portions created by TimeTrex are Copyright (C) 2004-2007 TimeTrex Payroll Services;
 * All Rights Reserved.
 *
 ********************************************************************************/
/*
 * $Revision: 153 $
 * $Id: EditClientContact.php 153 2006-09-28 22:25:03Z ipso $
 * $Date: 2006-09-28 15:25:03 -0700 (Thu, 28 Sep 2006) $
 */
require_once('../../includes/global.inc.php');
require_once(Environment::getBasePath() .'includes/Interface.inc.php');

if ( !$permission->Check('client','enabled')
		OR !( $permission->Check('client','edit') OR $permission->Check('client','edit_own') ) ) {

	$permission->Redirect( FALSE ); //Redirect

}

$title = 'Edit Client Contact';
$smarty->assign('title', $title);
BreadCrumb::setCrumb($title);

/*
 * Get FORM variables
 */
extract	(FormVariables::GetVariables(
										array	(
												'action',
												'id',
												'client_id',
												'data',
												) ) );
if ( isset($client_id) ) {
	$data['client_id'] = $client_id;
}

$ccf = new ClientContactFactory();
$action = strtolower($action);
switch ($action) {
	case 'submit':
		//Debug::setVerbosity(11);
		Debug::Text('Submit!', __FILE__, __LINE__, __METHOD__,10);

		$ccf->StartTransaction();

		$ccf->setId($data['id']);
		$ccf->setClient( $data['client_id'] );
		$ccf->setType($data['type_id']);
		if ( isset($data['default']) ) {
			$ccf->setDefault(TRUE);
		} else {
			$ccf->setDefault(FALSE);
		}
		$ccf->setFirstName($data['first_name']);
		$ccf->setLastName($data['last_name']);
		$ccf->setAddress1($data['address1']);
		$ccf->setAddress2($data['address2']);
		$ccf->setCity($data['city']);
		$ccf->setCountry($data['country']);
		$ccf->setProvince($data['province']);
		$ccf->setInvoiceDistrict($data['invoice_district_id']);
		$ccf->setPostalCode($data['postal_code']);
		$ccf->setWorkPhone($data['work_phone']);
		$ccf->setWorkPhoneExt($data['work_phone_ext']);
		$ccf->setMobilePhone($data['mobile_phone']);
		$ccf->setFaxPhone($data['fax_phone']);
		$ccf->setEmail($data['email']);

		if ( isset($data['other_id1']) ) {
			$ccf->setOtherID1( $data['other_id1'] );
		}
		if ( isset($data['other_id2']) ) {
			$ccf->setOtherID2( $data['other_id2'] );
		}
		if ( isset($data['other_id3']) ) {
			$ccf->setOtherID3( $data['other_id3'] );
		}
		if ( isset($data['other_id4']) ) {
			$ccf->setOtherID4( $data['other_id4'] );
		}
		if ( isset($data['other_id5']) ) {
			$ccf->setOtherID5( $data['other_id5'] );
		}

		$ccf->setNote($data['note']);

		if ( $ccf->isValid() ) {
			$ccf->Save(FALSE);

			if ( isset($data['include_tax_policy_ids']) ) {
				$ccf->setIncludeTaxPolicy($data['include_tax_policy_ids']);
			} else {
				$ccf->setIncludeTaxPolicy(FALSE);
			}

			if ( isset($data['exclude_tax_policy_ids']) ) {
				$ccf->setExcludeTaxPolicy($data['exclude_tax_policy_ids']);
			} else {
				$ccf->setExcludeTaxPolicy(FALSE);
			}

			if ( $ccf->isValid() ) {
				$ccf->Save();
				$ccf->CommitTransaction();

				Redirect::Page( URLBuilder::getURL( array('client_id' => $data['client_id'] ), 'ClientContactList.php') );

				break;
			}
		}
	default:
		if ( isset($id) AND $action != 'submit') {
			unset($data);

			Debug::Text('Client ID: '. $id, __FILE__, __LINE__, __METHOD__,10);
			$cclf = new ClientContactListFactory();

			//$uwlf->GetByUserIdAndCompanyId($current_user->getId(), $current_company->getId() );
			$cclf->getByIdAndCompanyId($id, $current_company->getId() );

			foreach ($cclf as $cc_obj) {
				$data = array(
									'id' => $cc_obj->getId(),
									'client_id' => $cc_obj->getClient(),
									'type_id' => $cc_obj->getType(),
									'default' => $cc_obj->getDefault(),
									'first_name' => $cc_obj->getFirstName(),
									'last_name' => $cc_obj->getLastName(),
									'email' => $cc_obj->getEmail(),
									'work_phone' => $cc_obj->getWorkPhone(),
									'work_phone_ext' => $cc_obj->getWorkPhoneExt(),
									'mobile_phone' => $cc_obj->getMobilePhone(),
									'fax_phone' => $cc_obj->getFaxPhone(),
									'address1' => $cc_obj->getAddress1(),
									'address2' => $cc_obj->getAddress2(),
									'city' => $cc_obj->getCity(),
									'province' => $cc_obj->getProvince(),
									'country' => $cc_obj->getCountry(),
									'invoice_district_id' => $cc_obj->getInvoiceDistrict(),
									'postal_code' => $cc_obj->getPostalCode(),
									'other_id1' => $cc_obj->getOtherID1(),
									'other_id2' => $cc_obj->getOtherID2(),
									'other_id3' => $cc_obj->getOtherID3(),
									'other_id4' => $cc_obj->getOtherID4(),
									'other_id5' => $cc_obj->getOtherID5(),
									'note' => $cc_obj->getNote(),

									'include_tax_policy_ids' => $cc_obj->getIncludeTaxPolicy(),
									'exclude_tax_policy_ids' => $cc_obj->getExcludeTaxPolicy(),

									'created_date' => $cc_obj->getCreatedDate(),
									'created_by' => $cc_obj->getCreatedBy(),
									'updated_date' => $cc_obj->getUpdatedDate(),
									'updated_by' => $cc_obj->getUpdatedBy(),
									'deleted_date' => $cc_obj->getDeletedDate(),
									'deleted_by' => $cc_obj->getDeletedBy()
								);
			}
		} elseif ( $action != 'submit' ) {
			$data['country'] = $current_company->getCountry();
			$data['province'] = $current_company->getProvince();
		}

		$data['type_options'] = $ccf->getOptions('type');

		$cf = new CompanyFactory();
		$data['country_options'] = $cf->getOptions('country');
		$data['province_options'] = $cf->getOptions('province', $data['country'] );

		$idlf = new InvoiceDistrictListFactory();
		$idlf->getByCompanyIdAndProvinceAndCountry( $current_company->getId(), $data['province'], $data['country'] );
		$data['invoice_district_options'] = $idlf->getArrayByListFactory( $idlf, TRUE );

		$tpolf = new TaxPolicyListFactory();
		$data['tax_policy_options'] = $tpolf->getByCompanyIdArray( $current_company->getId() );

		//Get other field names
		$oflf = new OtherFieldListFactory();
		$data['other_field_names'] = $oflf->getByCompanyIdAndTypeIdArray( $current_company->getId(), 55 );

		$smarty->assign_by_ref('data', $data);
		$smarty->assign_by_ref('client_id', $client_id);

		break;
}

$smarty->assign_by_ref('ccf', $ccf);

$smarty->display('client/EditClientContact.tpl');
?>