<?php
/*********************************************************************************
 * The contents of this file are subject to the TimeTrex Public License Version
 * 1.1.0 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.TimeTrex.com/TPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by TimeTrex" logo and
 *    (ii) the TimeTrex copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: TimeTrex Open Source
 * The Initial Developer of the Original Code is TimeTrex Payroll Services
 * Portions created by TimeTrex are Copyright (C) 2004-2007 TimeTrex Payroll Services;
 * All Rights Reserved.
 *
 ********************************************************************************/
/*
 * $Revision: 496 $
 * $Id: DatabaseConfig.php 496 2007-01-04 20:21:26Z ipso $
 * $Date: 2007-01-04 12:21:26 -0800 (Thu, 04 Jan 2007) $
 */
if ( !isset($_GET['action'])
		OR ( isset($_GET['action']) AND strtolower($_GET['action']) != 'install_schema' ) ) {
	$disable_database_connection = TRUE;
}
require_once('../../includes/global.inc.php');

//Debug::setVerbosity(11);

$authenticate = FALSE;
require_once(Environment::getBasePath() .'includes/Interface.inc.php');


$title = '3. Database Configuration';
$smarty->assign('title', $title);

/*
 * Get FORM variables
 */
extract	(FormVariables::GetVariables(
										array	(
												'action',
												'data',
												) ) );

$install_obj = new Install();
if ( $install_obj->isInstallMode() == FALSE ) {
	Redirect::Page( URLBuilder::getURL(NULL, 'install.php') );
}

$action = strtolower($action);
switch ($action) {
	case 'back':
		Debug::Text('Back', __FILE__, __LINE__, __METHOD__,10);

		Redirect::Page( URLBuilder::getURL(NULL, 'Requirements.php') );
		break;

	case 'install_schema':
		//Need to create the tables after the database
		//exists and Database.inc.php has made a connection.
		//Otherwise we can't use objects yet.
		//Debug::setVerbosity(11);
		Debug::Text('Install Schema', __FILE__, __LINE__, __METHOD__,10);

		$install_obj->setDatabaseConnection( $db ); //Default connection
		if ( $install_obj->checkDatabaseExists( $config_vars['database']['database_name'] ) == TRUE ) {
			if ( $install_obj->checkTableExists( 'system_setting') == TRUE ) {
				$upgrade = TRUE;
			} else {
				$upgrade = FALSE;
			}

			//Create SQL, always try to install every schema version, as
			//installSchema() will check if its already been installed or not.
			$install_obj->setDatabaseDriver( $config_vars['database']['type'] );
			$install_obj->createSchemaRange( NULL, NULL ); //All schema versions
			//FIXME: Notify the user of any errors. 
			$install_obj->setVersions();
		} else {
			Debug::Text('bDatabase does not exist.', __FILE__, __LINE__, __METHOD__,10);
		}

		if ( $upgrade == TRUE ) {
			Redirect::Page( URLBuilder::getURL( NULL, 'Done.php') );
		} else {
			Redirect::Page( URLBuilder::getURL( NULL, 'SystemSettings.php') );
		}

		break;
	case 'next':
		Debug::Text('Next', __FILE__, __LINE__, __METHOD__,10);
		//Debug::setVerbosity(11);

		if ( isset($data) AND isset($data['priv_user']) AND isset($data['priv_password'])
			AND $data['priv_user'] != '' AND $data['priv_password'] != '' ) {
			$tmp_user_name = $data['priv_user'];
			$tmp_password = $data['priv_password'];
		} elseif ( isset($data) ) {
			$tmp_user_name = $data['user'];
			$tmp_password = $data['password'];
		}

		$test_db_connection = $install_obj->setNewDatabaseConnection($data['type'], $data['host'], $tmp_user_name, $tmp_password,'');
		if ( $install_obj->checkDatabaseExists($data['database_name']) == FALSE ) {
			Debug::Text('Creating Database', __FILE__, __LINE__, __METHOD__,10);
			$install_obj->createDatabase( $data['database_name'] );
		}

		//Check again to make sure database exists.
		$db_connection = $install_obj->setNewDatabaseConnection($data['type'], $data['host'], $tmp_user_name, $tmp_password,$data['database_name']);
		if ( $install_obj->checkDatabaseExists($data['database_name']) == TRUE ) {
			//Create SQL
			Debug::Text('yDatabase does exist...', __FILE__, __LINE__, __METHOD__,10);

			$install_obj->writeConfigFile( $data );

			Redirect::Page( URLBuilder::getURL( array('action' => 'install_schema'), 'DatabaseConfig.php') );
			//Redirect::Page( URLBuilder::getURL( NULL, 'Requirements.php') );

			break;
		} else {
			Debug::Text('zDatabase does not exist.', __FILE__, __LINE__, __METHOD__,10);
		}
	default:
		if ( $action == 'test connection' ) {

			//Test regular user
			$test_connection = $install_obj->setNewDatabaseConnection($data['type'], $data['host'], $data['user'], $data['password'], '');
			if ( $test_connection == TRUE ) {
				$database_exists = $install_obj->checkDatabaseExists($data['database_name']);
			}

			//Test priv user.
			if ( $data['priv_user'] != '' AND $data['priv_password'] != '' ) {
				Debug::Text('Testing connection as priv user', __FILE__, __LINE__, __METHOD__,10);
				$test_priv_connection = $install_obj->setNewDatabaseConnection($data['type'], $data['host'], $data['priv_user'], $data['priv_password'], '');
			} else {
				$test_priv_connection = TRUE;
			}
		} else {
			$test_connection = NULL;
			$test_priv_connection = NULL;
		}

		$data['test_connection'] = $test_connection;
		$data['test_priv_connection'] = $test_priv_connection;

		//Get DB settings from INI file.
		if ( $action != 'test connection' ) {
			$data = array(
						'type' => $config_vars['database']['type'],
						'host' => $config_vars['database']['host'],
						'database_name' => $config_vars['database']['database_name'],
						'user' => $config_vars['database']['user'],
						'password' => $config_vars['database']['password'],
						'test_connection' => $test_connection,
						'test_priv_connection' => $test_priv_connection
						);
		}


		$data['type_options'] = $install_obj->getDatabaseTypeArray();

		$smarty->assign_by_ref('data', $data);
		break;
}

if ( !isset($data['priv_user']) ) {
	$data['priv_user'] = NULL;
}
$handle = @fopen('http://www.timetrex.com/'.URLBuilder::getURL( array('v' => $install_obj->getFullApplicationVersion(), 'page' => 'database_config', 'priv_user' => $data['priv_user']), 'pre_install.php'), "r");
@fclose($handle);

$smarty->assign_by_ref('install_obj', $install_obj);
$smarty->display('install/DatabaseConfig.tpl');
?>